package mk.ukim.finki.db.library.config;

import mk.ukim.finki.db.library.model.*;
import mk.ukim.finki.db.library.service.*;
import org.springframework.stereotype.Component;

import javax.annotation.PostConstruct;
import java.util.Collections;
import java.util.List;

@Component
public class DataInitializer {

    private final UserService userService;
    private final BookService bookService;
    private final WriterService writerService;
    private final GenreService genreService;
    private final LibraryService libraryService;
    private final SchoolTypeService schoolTypeService;
    private final MembershipTypeService membershipTypeService;
    private final RoomService roomService;
    private final PriceListService priceListService;

    public DataInitializer(UserService userService, BookService bookService, WriterService writerService, LibraryService libraryService, GenreService genreService, LibraryService libraryService1, SchoolTypeService schoolTypeService, MembershipTypeService membershipTypeService, RoomService roomService, PriceListService priceListService) {
        this.userService = userService;
        this.bookService = bookService;
        this.writerService = writerService;
        this.genreService = genreService;
        this.libraryService = libraryService1;
        this.schoolTypeService = schoolTypeService;
        this.membershipTypeService = membershipTypeService;
        this.roomService = roomService;
        this.priceListService = priceListService;
    }

    @PostConstruct
    public void initData(){
        Person member = this.userService.register("MemberName", "MemberSurname",
                "MemberAddress", "MemberTown", "071/111/222", "memberemail@hotmail.com", "baza123!");

        //LIBRARIES
        Library library = this.libraryService.create(1L,"Grigor Prlicev", "Ohrid");
//        this.libraryService.create(2L, "Braka Miladinovci", "Struga");
//        this.libraryService.create(3L, "Braka Miladinovci", "Skopje");

        //GENRES
        Genre genre = this.genreService.create(11L, "thriller");
        this.genreService.create(12L, "comedy");
        this.genreService.create(13L, "action");
        this.genreService.create(14L, "romance");
        this.genreService.create(15L, "history");
        this.genreService.create(16L, "teenage");

        //WRITERS
        Writer writer = this.writerService.create(111L, "Dan Brown");
        this.writerService.create(112L, "Linwood Barclay");
        this.writerService.create(113L, "Sebastian Fizek");
        this.writerService.create(114L, "Julie James");

       //BOOKS
        //this.bookService.createB(1112L,"Seat 7A", 5, true, 30, 50, List.of(1L), List.of(3L), 1L);
        this.bookService.create(1111L, "Inferno",3, true, 30, 50);
        this.bookService.create(1112L, "Seat 7A",2, true, 30, 50);
        this.bookService.create(1113L, "No time for goodbye",0, false, 30, 50);

//        this.bookService.createB(1114L,"Seat 7A", 5, true, 30, 50, Collections.singletonList(((Long) bookService.findById(2L).getGenre().getId())),
//                List.of(3L), 1L);

        //SCHOOLTYPES
        this.schoolTypeService.create(1L,"PRIMARY SCHOOL");
        this.schoolTypeService.create(2L,"HIGH SCHOOL");
        this.schoolTypeService.create(3L,"OTHER");

        //MEMBERSHIPTYPES
        this.membershipTypeService.create(1L, "WEEKLY");
        this.membershipTypeService.create(2L, "MONTHLY");
        this.membershipTypeService.create(3L, "YEARLY");

        //PRICELIST
        this.priceListService.create(1L, 70); //weekly - other
        this.priceListService.create(2L, 100); //monthy - other
        this.priceListService.create(3L, 300); //yearly - other
        this.priceListService.create(5L, 150); //yearly - primary school
        this.priceListService.create(6L, 300); //yearly - high school

        //ROOMS
        this.roomService.create(1L, "Room 1", 30, 8);
        this.roomService.create(2L, "Room 2", 20, 5);
        this.roomService.create(3L, "Room 3", 60, 60);

    }

}