package mk.ukim.finki.db.library.web;

import mk.ukim.finki.db.library.model.Book;
import mk.ukim.finki.db.library.model.Room;
import mk.ukim.finki.db.library.service.LibraryService;
import mk.ukim.finki.db.library.service.RoomService;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@Controller
@RequestMapping("/room")
public class RoomController {

    private final RoomService roomService;
    private final LibraryService libraryService;

    public RoomController(RoomService roomService, LibraryService libraryService) {
        this.roomService = roomService;
        this.libraryService = libraryService;
    }

    //will show all rooms with info for them
    @GetMapping
    public String showBooks(@RequestParam(required = false) String name,
                            Model model){

        List<Room> rooms;

        if(name == null){
            rooms = this.roomService.listAll();
        } else {
            rooms = this.roomService.findByName(name);
        }

        model.addAttribute("rooms", rooms);
        //model.addAttribute("libraries", libraries);

        return "room.html";
    }
}
